{
Copyright  Frdric MONTIN, 2008

dekibulle@free.fr
http://dekibulle.free.fr

**fr**

Ce logiciel est un programme informatique servant  lire des fichiers
audio sur ordinateur.

Ce fichier est une partie de dkibulle.

Dkibulle est un logiciel libre; soumis  une double licence. 
Vous pouvez le redistribuer ainsi que le modifier ds lors que vous respectez 
les termes *de l'une des deux licences*
- *soit* la licence GNU Lesser General Public License comme publie par la 
  Free Software Foundation, dans sa version 2 ou ultrieure; 
- *soit* la licence Cecill-C comme publie par Cecill,
  dans sa version 1 ou ultrieure.

**en**

This software is a computer program whose purpose is to listen audio
files on a computer.

This file is a part of Dkibulle.

Dkibulle is a free software; subjected to a double license.
You can redistribute it and/or modify since you respect the terms of either 
(at least one of the both license) :
- the GNU Lesser General Public License as published by the Free Software Foundation; 
  either version 2.1 of the License, or any later version. 
- the CeCILL-C as published by CeCILL; either version 1 of the License, or any later version.
}

unit DeKiBulleUtils;

interface

Uses  Windows, Classes, Graphics, Messages, StrUtils, CoolTrayIcon, SimpleTimer,
      SysUtils, IniFiles, Forms, Controls, ShellAPI, ID3v1, ID3v2, WMAFile, OGGVorbis, APETag, Unit_SongTagInfos,
      Unit1, Unit_Form_Options, Unit_Form_Tag, Unit_Form_Egaliseur, Unit_Form_InfoBulle, Bass, BassCD, Registry, InfoMPEG, HttpProt;

function  Split(S: string; d: Pchar): TStringList;
function  NomFichierSon(F: string): string;
procedure RadioName(handle: HSYNC; channel, data, user: DWORD); stdcall;
procedure ModName(channel: DWORD);
function  ValideExt(const F: string): boolean;
function  IsURL(const F: string): boolean;
function  IsMOD(const F: string): boolean;
function  IsPlayListe(const F: string) : boolean;
procedure MiseaJoursCouleurs(Totale : Boolean = True);
procedure Executer(const action : string; Parametre : Pchar = Nil);
procedure SetEqualizer(C: Boolean = True);
procedure SetVolume(ShowBalloon : Boolean = False);
function  CheckVersion(const AffSiNon : Boolean = True): Boolean;
procedure GetCDDB(Lecteur: integer);
function  ExtraitEXTINF(const Texte : string): string;
procedure MSNCurrentPlay(ARTIST, ALBUM, TITLE : string ; icone : Integer);
function  DeKiCrypte(const Texte : string): string;
function  DeKiDecrypte(Texte : string): string;
procedure RedemarreDeKi;

implementation

{------------------------------------------------------------------------}
{       fonction Split                                                   }
{------------------------------------------------------------------------}
function Split(S: string; d: Pchar): TStringList;
var
    Spliti: integer;
    Splitt: string;
begin
    Result := TStringList.Create;
    Splitt := '';
    for Spliti := 1 to Length(S) do begin  // une string a commence  1...
        if S[Spliti] = d then begin
            if Splitt <> '' then begin
                Result.Add(Splitt);
                Splitt := '';
            end;
        end else
            Splitt := Splitt + S[Spliti];
    end;
    if Splitt <> '' then
        Result.Add(Splitt);
end;

//============================================================================//
{             Renvoie le nom d'un fichier son  afficher                       }
//----------------------------------------------------------------------------//
function RemplaceTexteTag(const FormatNom, Duree, Artist, Album, TrackNb, TrackTitle, Rep1, Rep0, FileName, FileExt, Annee: String): String;
var
    t, t2: TStringList;
    i: integer;
begin
    t := Split(FormatNom, '$');
    Result := ' ';
    for i := 0 to t.Count - 1 do begin
        if AnsiContainsText(t[i], '|') then begin
            t2 := split(t[i], '|');
            if (AnsiContainsText(t2[0], '%artist') and (Trim(Artist) <> '')) then
                t[i] := AnsiReplaceText(t2[0], '%artist', Trim(Artist))
            else if (AnsiContainsText(t2[0], '%album') and (Trim(Album) <> '')) then
                t[i] := AnsiReplaceText(t2[0], '%album', Trim(Album))
            else if (AnsiContainsText(t2[0], '%tracknb') and (TrackNb <> '00')) then
                t[i] := AnsiReplaceText(t2[0], '%tracknb', TrackNb)
            else if (AnsiContainsText(t2[0], '%year') and (Annee <> '')) then
                t[i] := AnsiReplaceText(t2[0], '%year', Annee)
            else
                if (t2.Count = 2) then
                    t[i] := t2[1]
                else
                    t[i] := '';
            t2.Free;
        end else begin
            t[i] := AnsiReplaceText(t[i], '%length',     Duree);
            t[i] := AnsiReplaceText(t[i], '%artist',     Trim(Artist));
            t[i] := AnsiReplaceText(t[i], '%album',      Trim(Album));
            t[i] := AnsiReplaceText(t[i], '%tracknb',    TrackNb);
            t[i] := AnsiReplaceText(t[i], '%tracktitle', Trim(TrackTitle));
            t[i] := AnsiReplaceText(t[i], '%year',       Annee);
            t[i] := AnsiReplaceText(t[i], '%rep1',       Rep1);
            t[i] := AnsiReplaceText(t[i], '%rep0',       Rep0);
            t[i] := AnsiReplaceText(t[i], '%filename',   FileName);
            t[i] := AnsiReplaceText(t[i], '%fileext',    FileExt);
        end;
        Result := Result + t[i];
    end;
    t.Free;
end;
function RemplaceTexteSansTag(const FormatNom, Rep1, Rep0, FileName, FileExt, Duree: String): String;
begin
    Result := AnsiReplaceText(' ' + FormatNom, '%rep1',     Rep1);
    Result := AnsiReplaceText(Result,          '%rep0',     Rep0);
    Result := AnsiReplaceText(Result,          '%filename', FileName);
    Result := AnsiReplaceText(Result,          '%fileext',  FileExt);
    Result := AnsiReplaceText(Result,          '%length',   Duree);
end;
function NomFichierSon(F: string): string;
var
    Ext, Rep1, Rep0, Fichier : String;
    n        : TstringList;
    i, j : Integer;
    Duree, CDDBCDID    : String;
    LocalCDDBIni : TIniFile;
    TagInfos : TSongInfo;
    Info : BASS_CD_INFO;
begin
    Application.ProcessMessages;

        { Est-ce que le fichier est une URL ? }
    if IsURL(F) then begin
        Result := ' ' + F;
        Exit;
    end;

        { Est-ce que le fichier existe ? }
    if not(FileExists(F)) then begin
        Result := ' No File... ' + ExtractFileName(F);
        Exit;
    end;

    Ext     := LowerCase(ExtractFileExt(F));
    Fichier := Copy(ExtractFileName(F), 1, Length(ExtractFileName(F)) - Length(Ext));
    n       := Split(F, '\');
    With n do begin
      Rep0 := Strings[Count - 2];
      if Count >= 3 then
          Rep1 := Strings[Count - 3]
      else
          Rep1 := '';
      Free;
    end;
    Duree := '';

        { Si le fichier est un cda (CD audio) }
    if AnsiContainsText('$.cda$', Ext) then begin
        If OptionLireCDDB then begin
            i := 0;     // Dtermine le No du lecteur
            BASS_CD_GetInfo(i, Info);
            while (i < 10) and (Char(Info.letter + Ord('A')) <> F[1]) do begin
                i := i + 1;
                BASS_CD_GetInfo(i, Info);
            end;
            if i < 10 then begin
                        // Dtermine le CDID du lecteur
                CDDBCDID     := AnsiReplaceStr(BASS_CD_GetID(i, BASS_CDID_CDDB), ' ', '+');
                LocalCDDBIni := TIniFile.Create(ExtractFilePath(Application.Exename) + '\DeKiBulle.cddb');
                        // Cherche les infos sur la cddb locale
                with LocalCDDBIni do begin
                    if SectionExists(CDDBCDID) then begin
                        if ReadBool(CDDBCDID, 'MATCH', False) then begin
                            j := StrToInt(Copy(Fichier, 6, 2));    // No de Track
                            if ValueExists(CDDBCDID, Format('TITLE%d', [j])) then begin
                                Result := RemplaceTexteTag(FormatNomTag, ReadString(CDDBCDID, Format('LENGTH%d', [j]), ''), ReadString(CDDBCDID, 'ARTIST', ''), ReadString(CDDBCDID, 'ALBUM', ''), Format('%.2d', [j]), ReadString(CDDBCDID, Format('TITLE%d', [j]), ''), Rep1, Rep0, Fichier, Ext, ReadString(CDDBCDID, 'YEAR', ''));
                                Free;
                                Exit;
                            end;
                        end;
                    end else begin
                        with Form1.TimerCDDB do
                            if Not(Enabled) then begin
                                Tag     := i;
                                Enabled := True; // Dans quelques secondes on va tenter de regarder les infos CDDB...
                            end;
                    end;
                    Free;
                end;
            end; // Fin 'if i < 10'
        end;
        Result := RemplaceTexteSansTag(FormatNomCDA, Rep1, Rep0, Fichier, Ext, Duree);
        Exit;
    end;

    if OptionLireMetaTags then begin
        TagInfos := TSongInfo.Create;
        TagInfos.ReadFromFile(F, AnsiContainsText(FormatNomTag, '%length') OR AnsiContainsText(FormatNomSansTag, '%length'));
        Duree := TagInfos.Duree;
        if TagInfos.Tagged then begin
            Result := RemplaceTexteTag(FormatNomTag, TagInfos.Duree, TagInfos.Artist, TagInfos.Album, TagInfos.Track, TagInfos.Title, Rep1, Rep0, Fichier, Ext, TagInfos.Annee);
            TagInfos.Free;
            Exit;
        end;
        TagInfos.Free;
    end;

    if not OptionLireMetaTags and AnsiContainsText(FormatNomSansTag, '%length') then begin
      TagInfos := TSongInfo.Create;
      TagInfos.ReadLengthOfFile(F);
      Duree := TagInfos.Duree;
      TagInfos.Free;
    end;

        { Pas de TAGs du tout ou Not(OptionLireMetaTags) }
        { Lecture du chemin du fichier }
        { On suppose que le chemin est : ARTISTE\ALBUM\CHANSON.mp3 }
    Result := RemplaceTexteSansTag(FormatNomSansTag, Rep1, Rep0, Fichier, Ext, Duree)

end;

//============================================================================//
{             Nom de la net radio                                              }
//----------------------------------------------------------------------------//
procedure RadioName(handle: HSYNC; Channel, data, user: DWORD); stdcall;
var
  p : Integer;
  meta, icy : PChar;
  RadioName, SongTitle : String;
begin

        // Si le stream lu est un stream lastfm
    if (Form1.IndexMP3 > -1) and AnsiContainsText(Form1.ListeLecture[Form1.IndexMP3], '/last.mp3?session=') then begin
        With Form1 do begin
          ListBox1.Items[IndexMP3] := ' Last.fm Stream Radio';
          FormInfoBulle.Caption := ' ' + ' Last.fm Stream Radio';
          TrayIcon1.Hint := 'DKiBulle' + #13#10 + ' Last.fm Stream Radio';
          scrob.tsSessionID := RightStr((ListeLecture[IndexMP3]), 32);
          TimerLastFmPlaylist.Enabled := True;
          TimerLastFmPlaylist.Interval := 3000; // dans 3 sec on va voir le titre en cours
        end;
    end else begin

        // get the broadcast name
    icy := BASS_ChannelGetTags(Channel, BASS_TAG_ICY);
    if (icy <> nil) then
      while (icy^ <> #0) do begin
        if (Copy(icy, 1, 9) = 'icy-name:') then begin
          RadioName := Copy(icy, 10, MaxInt);
          Break;
        end;
        icy := icy + Length(icy) + 1;
      end;
    if (RadioName <> '') and (Form1.IndexMP3 > -1) then
        Form1.ListBox1.Items[Form1.IndexMP3] :=  ' ' + RadioName;

        // get the stream title
    meta := BASS_ChannelGetTags(Channel, BASS_TAG_META);
    if (meta <> nil) then begin
      p := Pos('StreamTitle=', meta);
      if (p <> 0) then begin
        p := p + 13;
        SongTitle := Trim(Copy(meta, p, Pos(';', meta) - p - 1));
      end;
    end;
    if SongTitle <> '' then
        With Form1 do begin
            FormInfoBulle.Caption := ' ' + SongTitle;
            TrayIcon1.Hint := 'DKiBulle' + #13#10 + FormInfoBulle.Caption;
            if Not(Affiche) and OptionAfficherBallon then
                FormInfoBulle.Affiche(TrayIcon1.Hint);
            if OptionMSNCurrentPlay then
                MSNCurrentPlay(FormInfoBulle.Caption, '', '', 1);
        end;

    end;

end;

//============================================================================//
{             Nom du fichier Mod                                               }
//----------------------------------------------------------------------------//
procedure ModName(channel: DWORD);
var
    SongTitle : String;
begin
    SongTitle := BASS_ChannelGetTags(Channel, BASS_TAG_MUSIC_NAME);
    if (SongTitle <> '') and (Form1.IndexMP3 > -1) then begin
        Form1.ListBox1.Items[Form1.IndexMP3] :=  ' ' + SongTitle;
        FormInfoBulle.Caption := ' ' + SongTitle;
        Form1.TrayIcon1.Hint := 'DKiBulle' + #13#10 + FormInfoBulle.Caption;
    end;
end;


//============================================================================//
{             Valide l'extension d'un fichier                                  }
//----------------------------------------------------------------------------//
function ValideExt(const F: string) : boolean;
var
    i : integer;
    E : string[5];
begin
    E := LowerCase(ExtractFileExt(F));
    for i := 0 to VEXT.Count - 1 do begin
        if E = '.' + VEXT[i] then begin
            Result := True;
            Exit;
        end;
    end;
    Result := False;
end;

//============================================================================//
{             Dtermine si F est une URL                                       }
//----------------------------------------------------------------------------//
function IsURL(const F: string) : boolean;
begin
    Result := (LowerCase(LeftStr(F, 7)) = 'http://') or (LowerCase(LeftStr(F, 6)) = 'mms://');
end;

//============================================================================//
{             Dtermine si F est un MOD                                        }
//----------------------------------------------------------------------------//
function IsMOD(const F: string) : boolean;
begin
    Result := AnsiContainsText('$.it$.xm$.s3m$.mod$.mtm$.umx$', ExtractFileExt(F));
end;

//============================================================================//
{             Dtermine si F est une playliste                                 }
//----------------------------------------------------------------------------//
function IsPlayListe(const F: string) : boolean;
begin
    Result := AnsiEndsText('.m3u', ExcludeTrailingPathDelimiter(F)) or
              AnsiEndsText('.pls', ExcludeTrailingPathDelimiter(F)) or
              AnsiEndsText('.xspf', ExcludeTrailingPathDelimiter(F)) or
              AnsiEndsText('.asx', ExcludeTrailingPathDelimiter(F));
end;

//============================================================================//
{                  Mise  jours des couleurs et des icnes                     }
//----------------------------------------------------------------------------//
procedure MiseaJoursCouleurs(Totale : Boolean = True);
var
    Ini,Skin  : Tinifile;
    Oldw,Oldh : integer;
    OldSkinBoutonsLeft, OldSkinBoutonsWidth, OldSkinBoutonsTop : Integer;
    OldSkinAnchorBottom : boolean;
    a : TAnchors;
    skinver : integer;
begin
            { Mise  jours des couleurs et polices }
    Ini  := Tinifile.Create(FichierIni);
    Skin := Tinifile.Create(RepSkin + 'skin.ini');
    with Skin do begin
                { Form 1 }
      With Form1 do begin

        PosRect.Left   := Left;
        PosRect.Top    := Top;
        PosRect.Right  := Width;
        PosRect.Bottom := Height;

        skinver := ReadInteger('VERSION', 'skinver', 330);
        //Form1.TrayIcon1.ShowBalloonHint('toto', IntToStr(skinver), bitInfo, 5000);

        if FileExists(RepSkin + ReadString('FOND', 'Backgroundbmpfile', 'no-back.bmp')) then begin
            if not Assigned(BmpFond) then
                BmpFond := TBitmap.Create;
            BmpFond.LoadFromFile(RepSkin + ReadString('FOND', 'Backgroundbmpfile', 'no-back.bmp'));
            BmpFondDuplicateW := ReadInteger('FOND', 'DuplicateW', BmpFond.Width div 2);
            BmpFondDuplicateH := ReadInteger('FOND', 'DuplicateH', BmpFond.Height div 2);
            if BmpFond.Width > 300 then
                Constraints.MinWidth := BmpFond.Width
            else
                Constraints.MinWidth := 300;
            if BmpFond.Height > 100 then
                Constraints.MinHeight := BmpFond.Height
            else
                Constraints.MinHeight := 100;
        end else
            if Assigned(BmpFond) then begin
                BmpFond.ReleaseHandle;
                BmpFond := nil;
            end;

        Color                 := ReadInteger('COLOR', 'ColorBackGround', $C8D0D4);
        TransparentColorValue := ReadInteger('FOND', 'TransparentColor', $FF00FF);
        TransparentColor      := ReadBool('FOND', 'TransparentActivate', False);
        With Canvas do begin
            Brush.Style := bsSolid;
            Brush.Color := Color;
            FillRect(Rect(0,0,Width,Height));
        end;
        DoubleBuffered := True;
        With PosRect do begin
            Oldw   := Right;
            Oldh   := Bottom;
            Right  := ReadInteger('POSITION', 'FormWidth',  300);  // Right  = Largeur
            Bottom := ReadInteger('POSITION', 'FormHeight', 380);  // Bottom = Hauteur
            SetBounds(Left, Top, Right, Bottom);
        end;
        With Panel_Listes do begin
            Left   := ReadInteger('POSITION', 'ListsLeft', 5);
            Top    := ReadInteger('POSITION', 'ListsTop', 5);
            Width  := ReadInteger('POSITION', 'ListsWidth', 290);
            Height := ReadInteger('POSITION', 'ListsHeight', 340);
        end;

                { compatibilit anciennes skins }
        OldSkinBoutonsLeft  := ReadInteger('POSITION', 'BouttonsLeft', 5) - 5;
        OldSkinBoutonsWidth := ReadInteger('POSITION', 'BouttonsWidth', 290) - 290;
        OldSkinBoutonsTop   := ReadInteger('POSITION', 'BouttonsTop', 345) - 345;
        OldSkinAnchorBottom := ReadBool('POSITION', 'BouttonsAnchorBottom', True);

                { Positions et images des boutons }
        With SpdBtnEgaliseur do begin
            Left := ReadInteger('POSITION', 'BtnEgaliseur-Left', OldSkinBoutonsLeft + 8);
            Top  := ReadInteger('POSITION', 'BtnEgaliseur-Top', OldSkinBoutonsTop + 349);
            if ReadBool('POSITION', 'BtnEgaliseur-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BtnEgaliseur-AnchorLeft', True) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
            if FileExists(RepSkin + ReadString('BUTTON', 'EqualizerBmpFile', '..\default\img_E.bmp')) then begin
              Glyph.LoadFromFile(RepSkin + ReadString('BUTTON', 'EqualizerBmpFile', '..\default\img_E.bmp'));

              if skinver > 330 then begin
                Width := Glyph.Width + 1;
                Height := Glyph.Height + 1;
              end else begin
                Width := 8;
                Height := 12;
              end;
            end;
        end;

        With SpdBtnOptions do begin
            Left := ReadInteger('POSITION', 'BtnOptions-Left', OldSkinBoutonsLeft + 8);
            Top  := ReadInteger('POSITION', 'BtnOptions-Top', OldSkinBoutonsTop + 361);
            if ReadBool('POSITION', 'BtnOptions-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BtnOptions-AnchorLeft', True) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
            if FileExists(RepSkin + ReadString('BUTTON', 'OptionsBmpFile', '..\default\img_O.bmp')) then begin
              Glyph.LoadFromFile(RepSkin + ReadString('BUTTON', 'OptionsBmpFile', '..\default\img_O.bmp'));
              if skinver > 330 then begin
                Width := Glyph.Width + 1;
                Height := Glyph.Height + 1;
              end else begin
                Width := 8;
                Height := 12;
              end;
            end;
        end;

        With SpdBtnRep do begin
            Left := ReadInteger('POSITION', 'BtnRep-Left', OldSkinBoutonsLeft + 18);
            Top  := ReadInteger('POSITION', 'BtnRep-Top', OldSkinBoutonsTop + 349);
            if ReadBool('POSITION', 'BtnRep-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BtnRep-AnchorLeft', True) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
            if FileExists(RepSkin + ReadString('BUTTON', 'RepBmpFile', '..\default\img_rep.bmp')) then begin
              ImageRep.Picture.LoadFromFile(RepSkin + ReadString('BUTTON', 'RepBmpFile', '..\default\img_rep.bmp'));
              If (Tag = 0) or (skinver < 331) then begin
                Glyph.Assign(ImageRep.Picture);
                if skinver > 330 then begin
                  Width := Glyph.Width + 6;
                  Height := Glyph.Height + 6;
                end else begin
                  Width := 35;
                  Height := 24;
                end;
              end;
            end;
            if (skinver > 330) and FileExists(RepSkin + ReadString('BUTTON', 'RepABmpFile', 'none')) then begin
              ImageRepA.Picture.LoadFromFile(RepSkin + ReadString('BUTTON', 'RepABmpFile', 'none'));
              ImageRepA.Tag := 1;
              Down := False;
              If Tag = 1 then begin
                Glyph.Assign(ImageRepA.Picture);
                Width := Glyph.Width + 6;
                Height := Glyph.Height + 6;
              end;
            end else begin
              ImageRepA.Tag := 0;
              Down := (Tag = 1);
            end;
        end;

        With SpdBtnListe do begin
            Left := ReadInteger('POSITION', 'BtnListe-Left', OldSkinBoutonsLeft + 56);
            Top  := ReadInteger('POSITION', 'BtnListe-Top', OldSkinBoutonsTop + 349);
            if ReadBool('POSITION', 'BtnListe-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BtnListe-AnchorLeft', True) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
            if FileExists(RepSkin + ReadString('BUTTON', 'ListeBmpFile', '..\default\img_liste.bmp')) then begin
              ImagePlaylist.Picture.LoadFromFile(RepSkin + ReadString('BUTTON', 'ListeBmpFile', '..\default\img_liste.bmp'));
              If (Tag = 0) or (skinver < 331) then begin
                Glyph.Assign(ImagePlaylist.Picture);
                if skinver > 330 then begin
                  Width := Glyph.Width + 6;
                  Height := Glyph.Height + 6;
                end else begin
                  Width := 35;
                  Height := 24;
                end;
              end;
            end;
            if (skinver > 330) and FileExists(RepSkin + ReadString('BUTTON', 'ListeABmpFile', 'none')) then begin
              ImagePlaylistA.Picture.LoadFromFile(RepSkin + ReadString('BUTTON', 'ListeABmpFile', 'none'));
              ImagePlaylistA.Tag := 1;
              Down := False;
              If Tag = 1 then begin
                Glyph.Assign(ImagePlaylistA.Picture);
                Width := Glyph.Width + 6;
                Height := Glyph.Height + 6;
              end;
            end else begin
              ImagePlaylistA.Tag := 0;
              Down := (Tag = 1);
            end;
        end;

        With LabelTemps do begin
            Left := ReadInteger('POSITION', 'LabelTemps-Left', OldSkinBoutonsLeft + 91);
            Top  := ReadInteger('POSITION', 'LabelTemps-Top', OldSkinBoutonsTop + 360);
            if ReadBool('POSITION', 'LabelTemps-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'LabelTemps-AnchorLeft', True) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
        end;

        With ProgressBar1 do begin
            Left  := ReadInteger('POSITION', 'BarPos-Left', OldSkinBoutonsLeft + 94);
            Top   := ReadInteger('POSITION', 'BarPos-Top', OldSkinBoutonsTop + 350);
            Width := ReadInteger('POSITION', 'BarPos-Width', 119 + OldSkinBoutonsWidth);
            if ReadBool('POSITION', 'BarPos-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BarPos-AnchorLeft', True) then
                a := a + [akLeft];
            if ReadBool('POSITION', 'BarPos-AnchorRight', True) then
                a := a + [akRight];
            Anchors := a;
        end;

        With ProgressBar2 do begin
            Left  := ReadInteger('POSITION', 'BarVol-Left', OldSkinBoutonsLeft + 147);
            Top   := ReadInteger('POSITION', 'BarVol-Top', OldSkinBoutonsTop + 362);
            Width := ReadInteger('POSITION', 'BarVol-Width', 66 + OldSkinBoutonsWidth);
            if ReadBool('POSITION', 'BarVol-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BarVol-AnchorLeft', True) then
                a := a + [akLeft];
            if ReadBool('POSITION', 'BarVol-AnchorRight', True) then
                a := a + [akRight];
            Anchors := a;
        end;

        With SpdBtnNext do begin
            Left := ReadInteger('POSITION', 'BtnNext-Left', OldSkinBoutonsLeft + 266 + OldSkinBoutonsWidth);
            Top  := ReadInteger('POSITION', 'BtnNext-Top', OldSkinBoutonsTop + 349);
            if ReadBool('POSITION', 'BtnNext-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BtnNext-AnchorLeft', False) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
            if FileExists(RepSkin + ReadString('BUTTON', 'NextBmpFile', '..\default\img_next.bmp')) then begin
              Glyph.LoadFromFile(RepSkin + ReadString('BUTTON', 'NextBmpFile', '..\default\img_next.bmp'));
              if skinver > 330 then begin
                Width := Glyph.Width + 6;
                Height := Glyph.Height + 6;
              end else begin
                Width := 24;
                Height := 24;
              end;
            end;
        end;

        With SpdBtnPlay do begin
            Left := ReadInteger('POSITION', 'BtnPlay-Left', OldSkinBoutonsLeft + 241 + OldSkinBoutonsWidth);
            Top  := ReadInteger('POSITION', 'BtnPlay-Top', OldSkinBoutonsTop + 349);
            if ReadBool('POSITION', 'BtnPlay-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BtnPlay-AnchorLeft', False) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
            if FileExists(RepSkin + ReadString('BUTTON', 'PlayBmpFile', '..\default\img_play.bmp')) then begin
              ImagePlay.Picture.LoadFromFile(RepSkin + ReadString('BUTTON', 'PlayBmpFile', '..\default\img_play.bmp'));
              if Not TimerAvancement.Enabled then begin
                Glyph.Assign(ImagePlay.Picture);
                if skinver > 330 then begin
                  Width := Glyph.Width + 6;
                  Height := Glyph.Height + 6;
                end else begin
                  Width := 24;
                  Height := 24;
                end;
              end;
            end;
            if FileExists(RepSkin + ReadString('BUTTON', 'PauseBmpFile', '..\default\img_pause.bmp')) then begin
              ImagePause.Picture.LoadFromFile(RepSkin + ReadString('BUTTON', 'PauseBmpFile', '..\default\img_pause.bmp'));
              if TimerAvancement.Enabled then begin
                Glyph.Assign(ImagePause.Picture);
                if skinver > 330 then begin
                  Width := Glyph.Width + 6;
                  Height := Glyph.Height + 6;
                end else begin
                  Width := 24;
                  Height := 24;
                end;
              end;
            end;
        end;

        With SpdBtnPrev do begin
            Left := ReadInteger('POSITION', 'BtnPrev-Left', OldSkinBoutonsLeft + 216 + OldSkinBoutonsWidth);
            Top  := ReadInteger('POSITION', 'BtnPrev-Top', OldSkinBoutonsTop + 349);
            if ReadBool('POSITION', 'BtnPrev-AnchorTop', not OldSkinAnchorBottom) then
                a := [akTop]
            else
                a := [akBottom];
            if ReadBool('POSITION', 'BtnPrev-AnchorLeft', False) then
                a := a + [akLeft]
            else
                a := a + [akRight];
            Anchors := a;
            if FileExists(RepSkin + ReadString('BUTTON', 'PrevBmpFile', '..\default\img_prec.bmp')) then begin
              Glyph.LoadFromFile(RepSkin + ReadString('BUTTON', 'PrevBmpFile', '..\default\img_prec.bmp'));
              if skinver > 330 then begin
                Width := Glyph.Width + 6;
                Height := Glyph.Height + 6;
              end else begin
                Width := 24;
                Height := 24;
              end;
            end;
        end;

        With TreeView1 do begin
            Color      := ReadInteger('COLOR', 'ClFondRep',   15658734);
            Font.Color := ReadInteger('COLOR', 'ClTexteRep',  5592405);
            Tag        := ReadInteger('COLOR', 'ClSurvolRep', 128);
            Font.Name  := ReadString('USERFONT', 'PoliceName', ReadString('FONT', 'PoliceName', 'Tahoma'));
            Font.Size  := ReadInteger('USERFONT', 'PoliceSize', ReadInteger('FONT', 'PoliceSize', 8));
            Font.Style := [fsUnderline];
            if ReadBool('USERFONT', 'PoliceBold', ReadBool('FONT', 'PoliceBold', True)) then
                Font.Style := Font.Style + [fsBold];
            if ReadBool('USERFONT', 'PoliceItalic', ReadBool('FONT', 'PoliceItalic', False)) then
                Font.Style := Font.Style + [fsItalic];
            Repaint;
        end;

        with Listbox1 do begin
            Color       := ReadInteger('COLOR', 'ClFondListe',    15658734);
            Font.Color  := ReadInteger('COLOR', 'ClTexteListe',   5592405);
            Tag         := ReadInteger('COLOR', 'ClPlayingListe', 128);
            PlayListSelectedColor := ReadInteger('COLOR', 'ClSelectedListe', $FFFFFF);
            Font.Name   := TreeView1.Font.Name;
            Font.Size   := TreeView1.Font.Size;
            Font.Style  := TreeView1.Font.Style - [fsUnderline];
            ScrollWidth := 0;
            Repaint;
        end;

        ProgressBar1.Brush.Color := ReadInteger('COLOR', 'ColorFondProgress', 5592405);
        ProgressBar2.Brush.Color := ReadInteger('COLOR', 'ColorFondVolume',   5592405);
        ProgressBar1.Tag         := ReadInteger('COLOR', 'ColorProgress', 15658734);
        ProgressBar2.Tag         := ReadInteger('COLOR', 'ColorVolume',   15658734);
        SendMessage(ProgressBar1.Handle, WM_USER + 9, 0, ProgressBar1.Tag);
        SendMessage(ProgressBar2.Handle, WM_USER + 9, 0, ProgressBar2.Tag);
        LabelTemps.Font.Color := ReadInteger('COLOR', 'ColorTimeText', $000000);

                  { Redimmensionne la fentre  la taille d'origine }
        With PosRect do begin
            Right  := Oldw;
            Bottom := Oldh;
            SetBounds(Left, Top, Right, Bottom);
        end;

        if Totale then begin

                  { Skin de la FormInfoBulle }
          FormInfoBulle.ChargeSkin;

                  { Form Egaliseur }
          if Assigned(FormEgaliseur) then
              FormEgaliseur.FormShow(nil);

                { Form 2 }
          if Assigned(FormOptions) then
          With FormOptions do begin
            SetCurrentDir(ExtractFileDir(FichierIni));
            F := ExpandFileName(Ini.ReadString('DATA', 'IconeFichiersAssocies', ''));
            if FileExists(F) then
                ImageIconeFichiers.Picture.Icon.LoadFromFile(F)
            else
                ImageIconeFichiers.Picture.Icon := FormInfoBulle.Icon;
            F := ExpandFileName(Ini.ReadString('DATA', 'Icone', ''));
            if FileExists(F) then
                ImageIconeBarreDesTaches.Picture.Icon.LoadFromFile(F)
            else
                ImageIconeBarreDesTaches.Picture.Icon := FormInfoBulle.Icon;
          end; // end with form2

                  { Icone barre des tches }
          SetCurrentDir(ExtractFileDir(FichierIni));
          F := ExpandFileName(Ini.ReadString('DATA', 'Icone', ''));
          if FileExists(F) then begin
              Icon.LoadFromFile(F);
          end else
              Icon := FormInfoBulle.Icon;
          With TrayIcon1 do begin
              Icon := Form1.Icon;
              BackgroundIcon := Icon;
          end;

        end; // end if Totale
      end; // end with form1
    end; // end with Ini
    Ini.Free;
    Skin.Free;
end;

//============================================================================//
{                  Executer une commande                                       }
//----------------------------------------------------------------------------//
procedure Executer(const action : string; Parametre : Pchar = Nil);
begin
    Screen.Cursor := crHourGlass;
    ShellExecute(Form1.Handle, Nil, PChar(action), Parametre, Nil, SW_SHOWNORMAL);
    Screen.Cursor := crDefault;
end;

//============================================================================//
{                  Active l'galiseur                                          }
//----------------------------------------------------------------------------//
procedure SetEqualizer(C: Boolean = True);
var
  i : integer;
begin
  With Form1 do
    if Channel <> 0 then
      for i := 1 to 10 do
          if eq[i] <> 0 then begin
            if ((fx[i] = 0) or C) then begin
              fx[i] := BASS_ChannelSetFX(Channel, BASS_FX_DX8_PARAMEQ, 1);
              //p.fBandwidth := 11.4;
              case i of
                1: p.fCenter := 80;
                2: p.fCenter := 170;
                3: p.fCenter := 310;
                4: p.fCenter := 600;
                5: p.fCenter := 1000;
                6: p.fCenter := 3000;
                7: p.fCenter := 6000;
                8: p.fCenter := 12000;
                9: p.fCenter := 14000;
                10: p.fCenter := 16000;
              end;
              case i of
                1: p.fBandwidth := 6.52;
                2: p.fBandwidth := 5.86;
                3: p.fBandwidth := 5.46;
                4: p.fBandwidth := 5.07;
                5: p.fBandwidth := 6.97;
                6: p.fBandwidth := 7.75;
                7: p.fBandwidth := 6.00;
                8: p.fBandwidth := 3.67;
                9: p.fBandwidth := 1.25;
                10: p.fBandwidth := 1.16;
              end;
            end else begin
              BASS_FXGetParameters(fx[i], @p);
            end;
            p.fGain := eq[i];
            BASS_FXSetParameters(fx[i], @p);
          end else begin
            BASS_ChannelRemoveFX(Channel, fx[i]);
            fx[i] := 0;
          end;
end;

//============================================================================//
{                  Defini le volume du channel                                 }
//----------------------------------------------------------------------------//
procedure SetVolume(ShowBalloon : Boolean = False);
begin
  With Form1 do begin
    if ProgressBar2.Position > 100 then ProgressBar2.Position := 100;
    if ProgressBar2.Position < 0   then ProgressBar2.Position := 0;
    if OptionVolumeGlobal then begin
      BASS_SetVolume(Sqr(ProgressBar2.Position / 10) / 100);                    //on change le volume de windows
      if Channel <> 0 then
        BASS_ChannelSetAttribute(Channel, BASS_ATTRIB_VOL, 1);                  //on remet le volume local a 1
    end else
      if Channel <> 0 then                                                      //on change le volume local
        BASS_ChannelSetAttribute(Channel, BASS_ATTRIB_VOL, Sqr(ProgressBar2.Position / 10) / 100);
    if Not Visible and ShowBalloon then
      TrayIcon1.ShowBalloonHint('', Format('Volume %d%%', [ProgressBar2.Position]), bitNone, 500);
  end;
end;
//----------------------------------------------------------------------------//


//============================================================================//
{          Vrifie si une nouvelle version est en ligne                        }
//----------------------------------------------------------------------------//
function CheckVersion(const AffSiNon : Boolean = True): Boolean;
var
    cl   : THttpCli;
    Data : TMemoryStream;
    v, t : string;
    IniLangue, Ini : TIniFile;
begin
    if AffSiNon then Screen.Cursor := crHourGlass;
    IniLangue        := TiniFile.Create(FichierLangue);
    Data             := TMemoryStream.Create;
    cl               := THttpCli.Create(nil);
    cl.MultiThreaded := True;
    Result           := False;
    try
        cl.URL        := 'http://dekibulle.free.fr/version.php';
        cl.RcvdStream := Data;
        Ini           := Tinifile.Create(FichierIni);
        with Ini do begin
            if ReadBool('PROXY', 'Activate', False) then begin
                cl.ProxyUsername := ReadString('PROXY', 'USER', '');
                cl.ProxyPassword := DeKiDecrypte(ReadString('PROXY', 'PASS', ''));
                cl.Proxy         := ReadString('PROXY', 'ADDRESS', '');
                cl.ProxyPort     := ReadString('PROXY', 'PORT', '');
            end;
            free;
        end;

        try
            cl.Get;
            v := Copy(StrPas(Data.Memory), 1, Data.Size);
            Result := True;
            Form1.TimerCheckVersion.Enabled := False;
            DecimalSeparator := '.';
            if (((Version[5] <> 'b') and (StrToFloat(v) > StrToFloat(Version)) or ((Version[5] = 'b') and (StrToFloat(v) >= StrToFloat(LeftStr(Version, 4)))))) then begin
            //if StrToFloat(v) > StrToFloat(Version) then begin
                t := IniLangue.ReadString('MESSAGES', '16', 'Nouvelle version disponible') + #13#10 + #13#10 + IniLangue.ReadString('MESSAGES', '17', 'Ouvrir le site?');
                if MessageBox(Form1.Handle, Pchar(t), 'DKiBulle', MB_ICONEXCLAMATION or MB_YESNO) = mrYes then
                    Executer('http://dekibulle.free.fr');
            end else begin
                t := IniLangue.ReadString('MESSAGES', '18', 'Dernire version');
                if AffSiNon then
                    MessageBox(Form1.Handle, Pchar(t), 'DKiBulle', MB_ICONQUESTION or MB_OK);
            end;
        except
            on E: EHttpException do begin
                t := IniLangue.ReadString('MESSAGES', '19', 'Erreur') + #13#10 + Cl.ReasonPhrase + #13#10 + IniLangue.ReadString('MESSAGES', '17', 'Ouvrir le site?');
                if AffSiNon then
                    if MessageBox(Form1.Handle, Pchar(t), 'DKiBulle', MB_ICONERROR or MB_YESNO) = mrYes then
                        Executer('http://dekibulle.free.fr');
            end else
                raise;
        end;
    finally
        Data.Free;
        cl.Free;
        IniLangue.Free;
        Screen.Cursor := crDefault;
    end;
end;

//============================================================================//
{        Recherche les infos CDDB et les crits dans la cddb locale            }
//----------------------------------------------------------------------------//
procedure GetCDDB(Lecteur: integer);
const
    FramePerSecond = 75;
    TimeAdj        = 86400;
var
    cl           : THttpCli;
    Data         : TMemoryStream;
    Reponse, CDDBCDIDListe : TStringList;
    i            : Integer;
    t            : String;
    LocalCDDBIni, Ini : TIniFile;
    CDDBCDID     : String;
    MettreAJours : Boolean;
    DureeSecondes : single;
begin
                // Cration des variables
    MettreAJours     := False;
    Data             := TMemoryStream.Create;
    cl               := THttpCli.Create(nil);
    cl.MultiThreaded := True;
    cl.RcvdStream    := Data;
    Ini := Tinifile.Create(FichierIni);
    with Ini do begin
        if ReadBool('PROXY', 'Activate', False) then begin
            cl.ProxyUsername := ReadString('PROXY', 'USER', '');
            cl.ProxyPassword := DeKiDecrypte(ReadString('PROXY', 'PASS', ''));
            cl.Proxy         := ReadString('PROXY', 'ADDRESS', '');
            cl.ProxyPort     := ReadString('PROXY', 'PORT', '');
        end;
        free;
    end;
    Reponse      := TStringList.Create;
    LocalCDDBIni := TIniFile.Create(ExtractFilePath(Application.Exename) + '\DeKiBulle.cddb');
    Form1.TrayIcon1.ShowHint := True;
    Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check...', bitInfo, 5000);
    try
                    // Dtermine le CDID du lecteur
        BASS_CD_GetID(Lecteur, BASS_CDID_CDDB);
        CDDBCDID := AnsiReplaceStr(BASS_CD_GetID(Lecteur, BASS_CDID_CDDB), ' ', '+');

                    // Regarde sur FreeDB.org si ce CD est rfrenc
        cl.URL := 'http://freedb.freedb.org:80/~cddb/cddb.cgi?cmd=cddb+query+' + CDDBCDID + '&hello=DeKiBulle+dekibulle.free.fr+DeKiBulle+' + Version + '&proto=5';
        cl.Get;

                    // Analyse la rponse obtenue
        t       := Copy(StrPas(Data.Memory), 1, Data.Size);
        Reponse := Split(t, ' ');
        if (Reponse[0] = '200') or (Reponse[0] = '210') then begin      //200 Found exact match

                        // Le CD est rfrenc, on demande les infos
            if Reponse[0] = '200' then
              cl.URL := 'http://freedb.freedb.org:80/~cddb/cddb.cgi?cmd=cddb+read+' + Reponse[1] + '+' + Reponse[2] + '&hello=DeKiBulle+dekibulle.free.fr+DeKiBulle+' + Version + '&proto=5'
            else
              cl.URL := 'http://freedb.freedb.org:80/~cddb/cddb.cgi?cmd=cddb+read+' + Copy(Reponse[8], 7, Length(Reponse[8])) + '+' + Reponse[9] + '&hello=DeKiBulle+dekibulle.free.fr+DeKiBulle+' + Version + '&proto=5';
            //Executer(cl.URL);
            Data.Clear;
            cl.Get;

                        // Analyse la rponse obtenue
            Reponse.Text := Copy(StrPas(Data.Memory), 1, Data.Size);
            if AnsiStartsText('210', Reponse[0]) then begin     //210 OK, CDDB database entry follows
                With LocalCDDBIni do begin
                            // Extraction de l'artiste et de l'album
                    t := Reponse.Values['DTITLE'];
                    WriteString(CDDBCDID, 'ARTIST', LeftStr(t, Pos(' / ', t) - 1));
                    WriteString(CDDBCDID, 'ALBUM',  RightStr(t, Length(t) - Pos(' / ', t) - 2));

                            // Extraction de l'anne et du genre
                    WriteString(CDDBCDID, 'YEAR',  Reponse.Values['DYEAR']);
                    WriteString(CDDBCDID, 'GENRE', Reponse.Values['DGENRE']);

                            // Extraction des dures et des titres des chansons et criture dans la CDDB locale
                    CDDBCDIDListe := Split(CDDBCDID, '+');
                    For i := 0 to StrToInt(CDDBCDIDListe[1]) - 1 do begin
                        WriteString(CDDBCDID, Format('TITLE%d', [i + 1]), Reponse.Values[Format('TTITLE%d', [i])]);
                        If i < StrToInt(CDDBCDIDListe[1]) - 1 then       //La dure des piste est calcule en fonction des "Track frame offsets"
                            DureeSecondes := (StrToInt(CDDBCDIDListe[i + 3]) - StrToInt(CDDBCDIDListe[i + 2])) / FramePerSecond
                            //t := Format('[%s]', [TimeToStr((StrToInt(CDDBCDIDListe[i + 3]) - StrToInt(CDDBCDIDListe[i + 2])) / FramePerSecond / TimeAdj)])
                        else
                            DureeSecondes := (StrToInt(CDDBCDIDListe[i + 3]) - StrToInt(CDDBCDIDListe[i + 2]) / FramePerSecond);
                            //t := Format('[%s]', [TimeToStr((StrToInt(CDDBCDIDListe[i + 3]) - StrToInt(CDDBCDIDListe[i + 2]) / FramePerSecond) / TimeAdj)]);
                        if DureeSecondes / TimeAdj >= 1/24 then
                            t := FormatDateTime('hh:nn:ss', DureeSecondes / TimeAdj)
                        else
                            t := FormatDateTime('nn:ss', DureeSecondes / TimeAdj);
                        WriteString(CDDBCDID, Format('LENGTH%d', [i + 1]), t);
                    end;
                    CDDBCDIDListe.Free;

                            // Tout  l'air de s'tre bien droul, on met Match  True et on mettra la liste de lecture  jours
                    WriteBool(CDDBCDID, 'MATCH', True);
                    //Form1.TrayIcon1.HideBalloonHint;
                    //Form1.TrayIcon1.ShowHint := False;
                    Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check... Match found!', bitInfo, 5000);
                    MettreAJours := True;
                end; // Fin 'with LocalCDDBIni'
            end else
                LocalCDDBIni.WriteBool(CDDBCDID, 'MATCH', False);               // Il y a eu une erreur, on met Match  False
        end else begin
            LocalCDDBIni.WriteBool(CDDBCDID, 'MATCH', False);                   // Le CD n'est pas rfrenc, on met Match  False
            Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check... No match found.', bitError, 5000);
        end;
    except
        on E: EHttpException do
            Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check... Failed.' + #13#10 + Cl.ReasonPhrase, bitError, 5000)
        else begin
            Form1.TrayIcon1.ShowBalloonHint('DKiBulle','CDDB Check... Failed.', bitError, 5000);
            raise
        end;
    end;

                // Libre les ressources
    cl.Free;
    Data.Free;
    Reponse.Free;
    LocalCDDBIni.Free;

                // Met  jours la liste de lecture si besoin
    if MettreAJours then
        Form1.MenuRefreshListeClick(nil);
end;

//============================================================================//
{        Extrait le nom de la chanson des ExtINF                               }
//----------------------------------------------------------------------------//
function ExtraitEXTINF(const Texte : string): string;
begin
    Result := '';
    if AnsiStartsText('#EXTINF:', Texte) and AnsiContainsStr(Texte, ',') then
        Result := Trim(RightStr(Texte, Length(Texte) - AnsiPos(',', Texte)));
end;

//============================================================================//
{        Envoie ce que j'coute  MSN (microsoft... bouh !)                    }
{  Source initiale par PoulpHunter                                             }
{ http://www.delphifr.com/codes/                                               }
{         MSN-ECOUTE-PSEUDO-NICKNAME-TEXTE-DEFILANT-CLIGNOTANT-DATE_32946.aspx }
//----------------------------------------------------------------------------//
procedure MSNCurrentPlay(ARTIST, ALBUM, TITLE : string ; icone : Integer);
var
  handleMSN    : THandle;
  structCopy   : TCopyDataStruct;
  stringBuffer : array [0..127] of WideChar;
  icones       : string;
begin

    FillChar(stringBuffer,SizeOf(stringBuffer),#0);
// Si icone vaut 0 alors MSN Ce que j''coute sera dsactiv
// Si icone:=1   =>  icone Music
// Si icone:=2   =>  icone Games
// Si icone:=3   =>  icone Office
    icones := 'Music';
    if icone >= 2 then begin
      icones := 'Games';
      if icone = 3 then
        icones := 'Office';
      icone := 1;
    end;
    StringToWideChar('\0'+icones+'\0'+inttostr(icone)+'\0'+'{0} - {1}'+'\0'+ARTIST+'\0'+TITLE+'\0'+ALBUM+'\0'+'WMContentID'+#0,@stringBuffer[0],128);
    //StringToWideChar('\0'+icones+'\0'+inttostr(icone)+'\0'+'{0}{1}'+'\0'+ARTIST+'\0'+TITLE+'\0'+ALBUM+'\0'+'WMContentID'+#0,@stringBuffer[0],128);

    FillChar(structCopy,SizeOf(TCopyDataStruct),#0);
    with structCopy do begin
      cbData := SizeOf(stringBuffer);
      dwData := $547;
      lpData := @stringBuffer[0];
    end;

    handleMSN := FindWindowEx(0,0,'MsnMsgrUIManager',nil);
    while handleMSN <> 0 do begin
      SendMessage(handleMSN, WM_COPYDATA, 0, Integer(@structCopy));
      handleMSN := FindWindowEx(0,handleMSN,'MsnMsgrUIManager',nil);
    end;
end;

//============================================================================//
{        Cryptage des mdp (trs, trs, basique!)                               }
//----------------------------------------------------------------------------//
function DeKiCrypte(const Texte : string): string;
var
    i : integer;
begin
    For i := 1 to length(Texte) do
        Result := Result + IntToHex(Ord(Texte[i]),2);
    Result := ReverseString(Result);
end;
function DeKiDecrypte(Texte : string): string;
var
    i : integer;
begin
    Texte := ReverseString(Texte);
    For i := 1 to Trunc(Length(Texte) / 2) do
        Result := Result + Chr(StrToIntDef('$'+Copy(Texte, i * 2 - 1, 2), 63)); // 63 = '?'
end;

//============================================================================//
{        Redmarre DKiBulle                                                   }
//----------------------------------------------------------------------------//
procedure RedemarreDeKi;
var
    t: TStringList;
    f: string;
begin
        // On crit un fichier .bat qui teint et redmarre DKiBulle
    t := TStringList.Create;
    f := ExtractFilePath(Application.Exename) + '_restart.bat';
    t.Add('dekibulle.exe /quit');
    t.Add('start dekibulle.exe /show');
    t.Add('del _restart.bat');
    t.SaveToFile(f);
    Executer(f);
end;



end.
