{
Copyright  Frdric MONTIN, 2008

dekibulle@free.fr
http://dekibulle.free.fr

**fr**

Ce logiciel est un programme informatique servant  lire des fichiers
audio sur ordinateur.

Ce fichier est une partie de dkibulle.

Dkibulle est un logiciel libre; soumis  une double licence. 
Vous pouvez le redistribuer ainsi que le modifier ds lors que vous respectez 
les termes *de l'une des deux licences*
- *soit* la licence GNU Lesser General Public License comme publie par la 
  Free Software Foundation, dans sa version 2 ou ultrieure; 
- *soit* la licence Cecill-C comme publie par Cecill,
  dans sa version 1 ou ultrieure.

**en**

This software is a computer program whose purpose is to listen audio
files on a computer.

This file is a part of Dkibulle.

Dkibulle is a free software; subjected to a double license.
You can redistribute it and/or modify since you respect the terms of either 
(at least one of the both license) :
- the GNU Lesser General Public License as published by the Free Software Foundation; 
  either version 2.1 of the License, or any later version. 
- the CeCILL-C as published by CeCILL; either version 1 of the License, or any later version.
}

unit Unit_Form_InfoBulle;

interface

uses
  Forms, IniFiles, ExtCtrls, StdCtrls, Classes, Controls, Windows, SimpleTimer, Graphics, SysUtils,
  StrUtils, dialogs;

type
  TFormInfoBulle = class(TForm)
    Label1: TLabel;
    ImgAlbum: TImage;
    procedure Affiche(Nom : String);
    procedure TimerInfoBulleTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure ChargeSkin;
  private
    { Dclarations prives }
    BeginTop, FinalTop : Integer;
  public
    { Dclarations publiques }
    BmpFond        : TBitmap;
    TextDistances  : TRect;
    TimerInfoBulle : TSimpleTimer;
    BmpFondDuplicateW, BmpFondDuplicateH:integer;
    LeftAnchor, TopAnchor : Boolean;
  end;

var
  FormInfoBulle: TFormInfoBulle;

implementation

uses Unit1;

{$R *.dfm}

procedure TFormInfoBulle.ChargeSkin;
var
    Skin : TIniFile;
begin
        { Chargement du skin de la FormInfoBulle }
    Skin := TIniFile.Create(RepSkin + 'skin.ini');
    With Skin do begin
        if FileExists(RepSkin + ReadString('INFOBULLE', 'Backgroundbmpfile', 'no-back.bmp')) then begin
            if not Assigned(BmpFond) then
                BmpFond := TBitmap.Create;
            BmpFond.LoadFromFile(RepSkin + ReadString('INFOBULLE', 'Backgroundbmpfile', 'no-back.bmp'));
            BmpFondDuplicateW := ReadInteger('INFOBULLE', 'DuplicateW', BmpFond.Width div 2);
            BmpFondDuplicateH := ReadInteger('INFOBULLE', 'DuplicateH', BmpFond.Height div 2);
            if BmpFond.Width > 100 then
                Constraints.MinWidth := BmpFond.Width
            else
                Constraints.MinWidth := 100;
            if BmpFond.Height > 40 then
                Constraints.MinHeight := BmpFond.Height
            else
                Constraints.MinHeight := 40;
        end else
            if Assigned(BmpFond) then begin
                BmpFond.ReleaseHandle;
                BmpFond := nil;
            end;
        Color                 := ReadInteger('INFOBULLE', 'ColorBackGround', 15658734);
        TransparentColorValue := ReadInteger('INFOBULLE', 'TransparentColor', $FF00FF);
        TransparentColor      := ReadBool('INFOBULLE', 'TransparentActivate', False);
        With Canvas do begin
            Brush.Style := bsSolid;
            Brush.Color := Color;
            FillRect(Rect(0,0,Width,Height));
        end;
        DoubleBuffered := True;
        With TextDistances do begin
            Left   := ReadInteger('INFOBULLE', 'TextLeftDistance', 5);
            Top    := ReadInteger('INFOBULLE', 'TextTopDistance', 5);
            Bottom := ReadInteger('INFOBULLE', 'TextBottomDistance', 5);
            Right  := ReadInteger('INFOBULLE', 'TextRightDistance', 5);
        end;
        With Label1 do begin
            Font.Color := ReadInteger('INFOBULLE', 'ColorText', 5592405);
            Font.Name  := ReadString('USERFONT', 'BalloonPoliceName', ReadString('FONT', 'BalloonPoliceName', Form1.ListBox1.Font.Name));
            Font.Size  := ReadInteger('USERFONT', 'BalloonPoliceSize', ReadInteger('FONT', 'BalloonPoliceSize', Form1.ListBox1.Font.Size));
            Font.Style := [];
            if ReadBool('USERFONT', 'BalloonPoliceBold', ReadBool('FONT', 'BalloonPoliceBold', fsBold in Form1.ListBox1.Font.Style)) then
                Font.Style := Font.Style + [fsBold];
            if ReadBool('USERFONT', 'BalloonPoliceItalic', ReadBool('FONT', 'BalloonPoliceItalic', fsItalic in Form1.ListBox1.Font.Style)) then
                Font.Style := Font.Style + [fsItalic];
        end;
    end;
    Skin.Free;
    Repaint;
end;

//============================================================================//
{          Mise  jours et dbut de l'apparition de l'info-bulle               }
//----------------------------------------------------------------------------//
procedure TFormInfoBulle.Affiche(Nom : String);
var
    ratio : single;
    Desk  : TRect;
begin
    Label1.WordWrap := False;
    Label1.Caption  := Nom;      // affiche le nom de la chanson

    if OptionAlbumCoverPreview and Form1.PanelPreviewAlbum.Visible then begin
        With Form1.ImgPreviewAlbum do begin
            ImgAlbum.Picture := Form1.ImgPreviewAlbum.Picture;
            ratio := Form1.PanelPreviewAlbum.Tag / 100;
            if ratio > 1 then begin
                ImgAlbum.Height := 70;
                ImgAlbum.Width  := Trunc(70 / ratio);
            end else begin
                ImgAlbum.Width  := 70;
                ImgAlbum.Height := Trunc(70 * ratio);
            end;
            ImgAlbum.Left := TextDistances.Left;
            ImgAlbum.Top  := TextDistances.Top;
            ImgAlbum.Show;
        end;
        Label1.Left := ImgAlbum.Left + ImgAlbum.Width + 5;
    end else begin
        ImgAlbum.Picture := nil;
        ImgAlbum.Hide;
        Label1.Left := TextDistances.Left;
    end;

    Width := Label1.Left + Label1.Width + TextDistances.Right;
    if Width > Screen.Width * 2 / 3 then begin      // Si l'info-bulle est trop grande on coupe le texte en deux
        Label1.Tag      := Label1.Width - (Width - Screen.Width * 2 div 3);
        Label1.WordWrap := True;
        Label1.Caption  := '';
        Label1.Width    := Label1.Tag;
        Label1.Caption  := Nom;
        Width := Label1.Left + Label1.Width + TextDistances.Right;
    end;

    if ImgAlbum.Visible and (ImgAlbum.Height > Label1.Height) then begin
        Height     := TextDistances.Top + ImgAlbum.Height + TextDistances.Bottom;
        Label1.Top := (Height - Label1.Height) div 2;
    end else begin
        Label1.Top := TextDistances.Top;
        Height     := TextDistances.Top + Label1.Height + TextDistances.Bottom;
    end;

    SystemParametersInfo(SPI_GETWORKAREA, 0, @Desk, 0);
    If LeftAnchor then
        Left := Desk.Left + 15
    else
        Left := Desk.Right - Width - 15;
    If TopAnchor then begin
        BeginTop := - Height;
        FinalTop := Desk.Top + 15;
    end else begin
        BeginTop := Screen.Height;
        FinalTop := Desk.Bottom - Height - 15;
    end;

    Top             := BeginTop;
    AlphaBlendValue := 0;
    AlphaBlend      := True;

    //Show;                               // on affiche la form
    Form1.TrayIcon1.HideTaskbarIcon;    // on chache le nom de la barre des taches
    With TimerInfoBulle do begin
        Interval := 10;                 // intervalle pour l'apparition
        Tag      := 0;                  // Timer1.Tag 0=apparition; 1=pause; 2=disparition
        Enabled  := True;               // on active le timer
    end;
    Visible := True;
    SetWindowPos(handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE);
    Repaint;
    Form1.TrayIcon1.HideTaskbarIcon;     // Cache l'appli de la barre des tches
end;

//============================================================================//
{             Timer pour l'affichage de la form                                }
//----------------------------------------------------------------------------//
procedure TFormInfoBulle.TimerInfoBulleTimer(Sender: TObject);
var
  pas, pasalpha : integer;
begin
  With TimerInfoBulle do begin
    //Show;                                               // on affiche la form pour tre sr qu'elle reste dessus
    Application.ProcessMessages;                        // petite pause pour reprendre son souffle

    pasalpha := 10;
    pas      := Round(Abs(Top - FinalTop) / 15 * (1 + Tag) + 2);
    Case Tag of
    0: begin
         if AlphaBlendValue < FormInfoBulle.Tag then
             if AlphaBlendValue + pasalpha > FormInfoBulle.Tag then
                 AlphaBlendValue := FormInfoBulle.Tag
             else
                 AlphaBlendValue := AlphaBlendValue + pasalpha;
         if TopAnchor then
             if Top + pas > FinalTop then
                 Top := FinalTop
             else
                 Top := Top + pas
         else
             if Top - pas < FinalTop then
                 Top := FinalTop
             else
                 Top := Top - pas;
         if ((AlphaBlendValue = FormInfoBulle.Tag) and (Top = FinalTop)) then begin
             Interval := 4000;
             Tag      := 1;
         end;
       end;
    1: begin
         Interval := 10;
         Tag      := 2;
       end;
    2: begin
        if AlphaBlendValue > 0 then
             if AlphaBlendValue - 2 * pasalpha < 0 then
                 AlphaBlendValue := 0
             else
                 AlphaBlendValue := AlphaBlendValue - 2 * pasalpha;
         if TopAnchor then
             if Top - pas < BeginTop then
                 Top := BeginTop
             else
                 Top := Top - pas
         else
             if Top + pas > BeginTop then
                 Top := BeginTop
             else
                 Top := Top + pas;
         if ((AlphaBlendValue = 0) and (Top = BeginTop)) then begin
             Enabled := False;
             Hide;
         end;
       end;
    end;

  end;

end;

//============================================================================//
{              Affiche la Form1 si clic sur l'info bulle                       }
//----------------------------------------------------------------------------//
procedure TFormInfoBulle.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    Form1.AfficheForm;       // affiche la form1
end;

//============================================================================//
{             Cration de la Form info-bulle                                   }
//----------------------------------------------------------------------------//
procedure TFormInfoBulle.FormCreate(Sender: TObject);
begin
    TimerInfoBulle := TSimpleTimer.Createex(50, TimerInfoBulleTimer);
end;

//============================================================================//
{             Affichage de la Form info-bulle (image de fond)                  }
//----------------------------------------------------------------------------//
procedure TFormInfoBulle.FormPaint(Sender: TObject);
var
    w,h : integer;
begin
  if Assigned(BmpFond) then begin
    w := BmpFondDuplicateW;
    h := BmpFondDuplicateH;
    With Canvas do begin
        CopyRect(Rect(0, 0, w, h), BmpFond.Canvas, Rect(0, 0, w, h)); //HAUT GAUCHE
        CopyRect(Rect(Width - (BmpFond.Width - w - 1), 0, Width, h), BmpFond.Canvas, Rect(w + 1, 0, BmpFond.Width, h)); //HAUT DROITE
        CopyRect(Rect(w, 0, Width - (BmpFond.Width - w - 1), h), BmpFond.Canvas, Rect(w, 0, w + 1, h)); //HAUT MILIEU
        CopyRect(Rect(0, Height - (BmpFond.Height - h - 1), w, Height), BmpFond.Canvas, Rect(0, h + 1, w, BmpFond.Height)); //BAS GAUCHE
        CopyRect(Rect(0, h, w, Height - (BmpFond.Height - h - 1)), BmpFond.Canvas, Rect(0, h, w, h + 1)); //MILIEU GAUCHE
        CopyRect(Rect(Width - (BmpFond.Width - w - 1), Height - (BmpFond.Height - h - 1), Width, Height), BmpFond.Canvas, Rect(w + 1, h + 1, BmpFond.Width, BmpFond.Height)); //BAS DROITE
        CopyRect(Rect(Width - (BmpFond.Width - w - 1), h, Width, Height - (BmpFond.Height - h - 1)), BmpFond.Canvas, Rect(w + 1, h, BmpFond.Width, h + 1)); //MILIEU DROITE
        CopyRect(Rect(w, Height - (BmpFond.Height - h - 1), Width - (BmpFond.Width - w - 1), Height), BmpFond.Canvas, Rect(w, h + 1, w + 1, BmpFond.Height)); //BAS MILIEU
        CopyRect(Rect(w, h, Width - (BmpFond.Width - w - 1), Height - (BmpFond.Height - h - 1)), BmpFond.Canvas, Rect(w, h, w + 1, h + 1)); //MILIEU
    end;
  end;
end;

end.
