{
Copyright  Frdric MONTIN, 2008

dekibulle@free.fr
http://dekibulle.free.fr

**fr**

Ce logiciel est un programme informatique servant  lire des fichiers
audio sur ordinateur.

Ce fichier est une partie de dkibulle.

Dkibulle est un logiciel libre; soumis  une double licence.
Vous pouvez le redistribuer ainsi que le modifier ds lors que vous respectez
les termes *de l'une des deux licences*
- *soit* la licence GNU Lesser General Public License comme publie par la
  Free Software Foundation, dans sa version 2 ou ultrieure;
- *soit* la licence Cecill-C comme publie par Cecill,
  dans sa version 1 ou ultrieure.

**en**

This software is a computer program whose purpose is to listen audio
files on a computer.

This file is a part of Dkibulle.

Dkibulle is a free software; subjected to a double license.
You can redistribute it and/or modify since you respect the terms of either
(at least one of the both license) :
- the GNU Lesser General Public License as published by the Free Software Foundation;
  either version 2.1 of the License, or any later version.
- the CeCILL-C as published by CeCILL; either version 1 of the License, or any later version.
}

unit Unit_Form_Recherche;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, FileCtrl;

type
  TFormRecherche = class(TForm)
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox3: TCheckBox;
    ProgressBar: TProgressBar;
    BtnRechercher: TBitBtn;
    GroupBox2: TGroupBox;
    TexteRecherche: TEdit;
    Label1: TLabel;
    GroupBox3: TGroupBox;
    RepertoireDeRecherche: TEdit;
    CheckSsRep: TCheckBox;
    BtnAnnuler: TBitBtn;
    BtnChangeFolder: TButton;
    procedure FormShow(Sender: TObject);
    procedure TexteRechercheChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnRechercherClick(Sender: TObject);
    procedure BtnAnnulerClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtnChangeFolderClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormRecherche: TFormRecherche;

implementation

uses Unit1, DeKiBulleUtils, StrUtils, ID3v1,
  ID3v2, WMAFile, OGGVorbis, Unit_Gestion_Langue;

{$R *.dfm}

procedure TFormRecherche.FormShow(Sender: TObject);
begin
    Application.NormalizeAllTopMosts;
                { Gestion de la langue }
    GestionLangue(5);
    ProgressBar.Position := 0;
                { On replace la form }
    if Form1.Left - Width > 0 then
        Left := Form1.Left - Width;
    Top := Form1.Top;
    //SetCursorPos(Left + Width div 2, Top + Height div 2);
    
    RepertoireDeRecherche.SelStart := Length(RepertoireDeRecherche.Text);
    TexteRecherche.SetFocus;
end;

procedure TFormRecherche.TexteRechercheChange(Sender: TObject);
begin
    BtnRechercher.Enabled := (TexteRecherche.Text <> '') and (CheckBox1.Checked or CheckBox2.Checked or CheckBox3.Checked or CheckBox4.Checked or CheckBox5.Checked);
end;

procedure TFormRecherche.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    BtnAnnuler.Enabled := False;
    Application.RestoreTopMosts;
    Action := caFree;  // libre la mmoire
    FormRecherche := nil;
end;

procedure TFormRecherche.BtnRechercherClick(Sender: TObject);
var
    j        : Integer;
    listerep : TStringList;
    sr       : TSearchRec;
    b        : boolean;
    MP3Tagv1 : TID3v1;
    MP3Tagv2 : TID3v2;
    WMATag   : TWMAfile;
    OGGTag   : TOggVorbis;
begin
    BtnRechercher.Enabled := False;
    BtnAnnuler.Enabled    := True;
    Form1.ListBox1.ClearSelection;
            { Cherche les fichiers audio contenus dans le repertoire Rep }
            { et dans ses sous-rpertoires (si Recurse==True) }
            { tout d'abord on cre la liste des rpertoires }
    listerep := TstringList.Create;
    listerep.Add(IncludeTrailingPathDelimiter(RepertoireDeRecherche.Text));
    if CheckSsRep.Checked then begin
        j := 0;
        while j <= listerep.Count - 1 do begin
            if Findfirst(listerep[j] + '*.*', faAnyFile, sr) = 0 then begin
                repeat
                    if ((sr.Attr and faDirectory) <> 0) and (sr.Name <> '.') and (sr.Name <> '..') then
                        listerep.Add(listerep[j] + sr.name + '\');
                until Findnext(sr) <> 0;
                FindClose(sr);
            end;
            Inc(j);
            Application.ProcessMessages;
            if Not BtnAnnuler.Enabled then begin
                BtnRechercher.Enabled := True;
                Exit;
            end;
        end;
        listerep.Sort;
    end;
    ProgressBar.Max := listerep.Count;
            { on cherche tout les fichiers audio contenus dans les rpertoires de la liste }
    for j := 0 to listerep.Count - 1 do begin
        if Findfirst(listerep[j] + '*.*', faAnyFile, sr) = 0 then begin
            repeat
                if ValideExt(sr.name) then begin
                    b := False;
                    If CheckBox1.Checked then
                        b := ANSIContainsText(listerep[j], TexteRecherche.Text);
                    If CheckBox2.Checked and Not b then
                        b := ANSIContainsText(sr.Name, TexteRecherche.Text);
                    If Not b and (CheckBox3.Checked or CheckBox4.Checked or CheckBox5.Checked) then begin
                        if AnsiContainsText('$.mp3$.mp2$', ExtractFileExt(sr.name)) then begin
                            MP3Tagv2 := TID3v2.Create;
                            With MP3Tagv2 do begin
                                ReadFromFile(listerep[j] + sr.name);
                                if Exists then begin
                                    if CheckBox3.Checked then
                                        b := ANSIContainsText(Title, TexteRecherche.Text);
                                    if CheckBox4.Checked and Not b then
                                        b := ANSIContainsText(Artist, TexteRecherche.Text);
                                    if CheckBox5.Checked and Not b then
                                        b := ANSIContainsText(Album, TexteRecherche.Text);
                                end;
                                Free;
                            end;
                        end;
                        if Not b and AnsiContainsText('$.mp3$.mp2$.mpc$', ExtractFileExt(sr.name)) then begin
                            MP3Tagv1 := TID3v1.Create;
                            With MP3Tagv1 do begin
                                ReadFromFile(listerep[j] + sr.name);
                                if Exists then begin
                                    if CheckBox3.Checked then
                                        b := ANSIContainsText(Title, TexteRecherche.Text);
                                    if CheckBox4.Checked and Not b then
                                        b := ANSIContainsText(Artist, TexteRecherche.Text);
                                    if CheckBox5.Checked and Not b then
                                        b := ANSIContainsText(Album, TexteRecherche.Text);
                                end;
                                Free;
                            end;
                        end;
                        if AnsiContainsText('$.wma$', ExtractFileExt(sr.name)) then begin
                            WMATag := TWMAfile.Create;
                            With WMATag do begin
                                ReadFromFile(listerep[j] + sr.name);
                                if Valid then begin
                                    if CheckBox3.Checked then
                                        b := ANSIContainsText(Title, TexteRecherche.Text);
                                    if CheckBox4.Checked and Not b then
                                        b := ANSIContainsText(Artist, TexteRecherche.Text);
                                    if CheckBox5.Checked and Not b then
                                        b := ANSIContainsText(Album, TexteRecherche.Text);
                                end;
                                Free;
                            end;
                        end;
                        if AnsiContainsText('$.ogg$', ExtractFileExt(sr.name)) then begin
                            OGGTag := TOggVorbis.Create;
                            With OGGTag do begin
                                ReadFromFile(listerep[j] + sr.name);
                                if Valid then begin
                                    if CheckBox3.Checked then
                                        b := ANSIContainsText(Title, TexteRecherche.Text);
                                    if CheckBox4.Checked and Not b then
                                        b := ANSIContainsText(Artist, TexteRecherche.Text);
                                    if CheckBox5.Checked and Not b then
                                        b := ANSIContainsText(Album, TexteRecherche.Text);
                                end;
                                Free;
                            end;
                        end;
                    end;
                    if b then
                        With Form1 do begin
                            ListeLecture.Add(listerep[j] + sr.name);
                            With ListBox1 do begin
                                Items.Add(NomFichierSon(listerep[j] + sr.name));
                                Selected[Count - 1] := True;
                            end;
                        end;
                end;
            until Findnext(sr) <> 0;
            FindClose(sr);
        end;
        ProgressBar.Position := j + 1;
        Application.ProcessMessages;
        if Not BtnAnnuler.Enabled then begin
            BtnRechercher.Enabled := True;
            Exit;
        end;
    end;
    listerep.Free;
    BtnRechercher.Enabled := True;
    BtnAnnuler.Enabled    := False;
end;

procedure TFormRecherche.BtnAnnulerClick(Sender: TObject);
begin
    BtnAnnuler.Enabled := False;
end;

procedure TFormRecherche.CheckBox1Click(Sender: TObject);
begin
    TexteRechercheChange(nil);
end;

procedure TFormRecherche.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = 13) and BtnRechercher.Enabled then
        BtnRechercherClick(nil);
end;

procedure TFormRecherche.BtnChangeFolderClick(Sender: TObject);
var
    dir : string;
begin
    if SelectDirectory(GroupBox3.Caption, '', dir) then
        With RepertoireDeRecherche do begin
            Text := IncludeTrailingPathDelimiter(dir);
            SelStart := Length(Text);
        end;
end;

end.
