; BASSCD 2.3 MASM API, (c) 2003-2005 Ian Luck.
; Requires BASS 2.3 - available from www.un4seen.com

; See the BASSCD.CHM file for more complete documentation

; Additional error codes returned by BASS_ErrorGetCode
BASS_ERROR_NOCD             equ 12 ; no CD in drive
BASS_ERROR_CDTRACK          equ 13 ; invalid track number
BASS_ERROR_NOTAUDIO         equ 17 ; not an audio track

; Additional config option
BASS_CONFIG_CD_FREEOLD      equ 10200h
BASS_CONFIG_CD_RETRY        equ 10201h
BASS_CONFIG_CD_AUTOSPEED    equ 10202h
BASS_CONFIG_CD_SKIPERROR    equ 10203h

BASS_CD_INFO struct
        ssize    DWORD   ?      ; size of this struct (set this before calling the function)
        rwflags  DWORD   ?      ; read/write capability flags
        canopen  DWORD   ?      ; BASS_CD_DOOR_OPEN/CLOSE is supported?
        canlock  DWORD   ?      ; BASS_CD_DOOR_LOCK/UNLOCK is supported?
        maxspeed DWORD   ?      ; max read speed (KB/s)
        cache    DWORD   ?      ; cache size (KB)
        cdtext   DWORD   ?      ; can read CD-TEXT
BASS_CD_INFO ends

; "rwflag" read capability flags
BASS_CD_RWFLAG_READCDR      equ 1
BASS_CD_RWFLAG_READCDRW     equ 2
BASS_CD_RWFLAG_READCDRW2    equ 4
BASS_CD_RWFLAG_READDVD      equ 8
BASS_CD_RWFLAG_READDVDR     equ 16
BASS_CD_RWFLAG_READDVDRAM   equ 32
BASS_CD_RWFLAG_READANALOG   equ 10000h
BASS_CD_RWFLAG_READM2F1     equ 100000h
BASS_CD_RWFLAG_READM2F2     equ 200000h
BASS_CD_RWFLAG_READMULTI    equ 400000h
BASS_CD_RWFLAG_READCDDA     equ 1000000h
BASS_CD_RWFLAG_READCDDASIA  equ 2000000h
BASS_CD_RWFLAG_READSUBCHAN  equ 4000000h
BASS_CD_RWFLAG_READSUBCHANDI equ 8000000h
BASS_CD_RWFLAG_READISRC     equ 20000000h
BASS_CD_RWFLAG_READUPC      equ 40000000h

; additional BASS_CD_StreamCreate/File flags
BASS_CD_SUBCHANNEL      equ 200h
BASS_CD_SUBCHANNEL_NOHW equ 400h

; additional CD sync type
BASS_SYNC_CD_ERROR      equ 1000
BASS_SYNC_CD_SPEED      equ 1002

; BASS_CD_Door actions
BASS_CD_DOOR_CLOSE      equ 0
BASS_CD_DOOR_OPEN       equ 1
BASS_CD_DOOR_LOCK       equ 2
BASS_CD_DOOR_UNLOCK     equ 3

; BASS_CD_GetID flags
BASS_CDID_UPC       equ 1
BASS_CDID_CDDB      equ 2
BASS_CDID_CDDB2     equ 3
BASS_CDID_TEXT      equ 4
BASS_CDID_CDPLAYER  equ 5
BASS_CDID_MUSICBRAINZ equ 6
BASS_CDID_ISRC      equ 100h ; + track #

; BASS_CHANNELINFO type
BASS_CTYPE_STREAM_CD    equ 10200h


BASS_CD_GetDriveDescription PROTO :DWORD
BASS_CD_GetDriveLetter      PROTO :DWORD
BASS_CD_GetInfo             PROTO :DWORD,:DWORD
BASS_CD_Door                PROTO :DWORD,:DWORD
BASS_CD_DoorIsOpen          PROTO :DWORD
BASS_CD_DoorIsLocked        PROTO :DWORD
BASS_CD_IsReady             PROTO :DWORD
BASS_CD_GetTracks           PROTO :DWORD
BASS_CD_GetTrackLength      PROTO :DWORD,:DWORD
BASS_CD_GetTrackPregap      PROTO :DWORD,:DWORD
BASS_CD_GetID               PROTO :DWORD,:DWORD
BASS_CD_GetSpeed            PROTO :DWORD
BASS_CD_SetSpeed            PROTO :DWORD,:DWORD
BASS_CD_Release             PROTO :DWORD

BASS_CD_StreamCreate        PROTO :DWORD,:DWORD,:DWORD
BASS_CD_StreamCreateFile    PROTO :DWORD,:DWORD
BASS_CD_StreamGetTrack      PROTO :DWORD
BASS_CD_StreamSetTrack      PROTO :DWORD,:DWORD

BASS_CD_Analog_Play         PROTO :DWORD,:DWORD,:DWORD
BASS_CD_Analog_PlayFile     PROTO :DWORD,:DWORD
BASS_CD_Analog_Stop         PROTO :DWORD
BASS_CD_Analog_IsActive     PROTO :DWORD
BASS_CD_Analog_GetPosition  PROTO :DWORD
